
import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;
import javax.swing.border.*;
import java.util.* ; 
import java.io.* ; 
import java.awt.datatransfer.* ; 
import java.net.* ; 

/**
  *  AutoLogApp "Works like an app, comes in a jar."
  *  10/1/2020 { prevent drag off screen bottom/right } 
  *  NOTE: If ~/autolog is relocated, you need to modify line 144.
  *  @version 11/6/2022 (AUTOLOGapp.png)
  *  @author &copy; John Fisher
  */
public class AutoLogApp extends JFrame {
   private int x, y ;
   private int down_x, down_y ; 
   private boolean moving ;
   private int launched ;
   private static Color DefaultColor = Color.WHITE ;
   private Dimension screen_size ;  // 10/1/2020
   private int W, H ;  // actual size of autolog22 ikon image

   public AutoLogApp() {
      this.launched = 0 ;
      Class cls = this.getClass() ;        // need image ↘ for app  in the jar           
      ImageIcon icon = new ImageIcon(cls.getResource("images/AUTOLOGapp.png")) ;
      this.W = 98 ;      // preferred image width
      this.H = 122 ;     // preferred image height 
      float S = (float)0.75 ; // scale   adjust here 
      this.W = (int)(S*W) ;  System.out.println("width = \""+W+"\" ") ;
      this.H = (int)(S*H) ;
      Image icon_image = 
         icon.getImage().getScaledInstance(W,H,Image.SCALE_SMOOTH) ; // preferred size
      icon.setImage(icon_image) ; 
      JLabel icon_label = new JLabel(icon) ; 
      this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE) ;   
      final AutoLogApp self = this ; 
      this.screen_size = this.getToolkit().getScreenSize() ; // 10/1/2020 stay inside viewport
      this.addMouseListener( new MouseAdapter() {
         public void mouseDown(MouseEvent e) {
            down_x = e.getX() ; down_y = e.getY() ; 
         }
         public void mouseReleased(MouseEvent e) {  // save new location
            if (moving) {
               moving = false ;
               Properties now = new Properties() ; 
               Point p = getLocation() ;
               now.put("x",String.valueOf(p.x)) ; 
               now.put("y",String.valueOf(p.y)) ; 
               try { 
                  FileOutputStream fos = 
                     new FileOutputStream(
                       System.getProperty("user.home")+File.separator+"AutoLogApp.settings") ; 
                  now.store(fos, "AutoCoLogApp user properties") ; 
               }
               catch(Exception x) {  
                  System.out.println(x) ; 
               }
            }
         }
         public void mouseClicked(MouseEvent e) {
            if (e.getClickCount() >= 2) {
               // TEMPORARY for dev, use jar eventually
               // cmdarr entries can have NO leading or trailing spaces
               String[] cmdarr = 
                 {  "java" , "-cp", 
                     System.getProperty("user.home")+File.separator+"autolog", 
                     "sam.gui.edit.AutoLogEditor" } ;    
               try { 
                  Runtime.getRuntime().exec(cmdarr) ; 
               }catch(Exception xx) { System.out.println(xx) ; } 
               // DEPRECATED in Java 19  Runtime.getRuntime().exec(String cmd)
            }
         }
      }) ;   
      this.addMouseMotionListener( new MouseMotionAdapter() {
         public void mouseDragged(MouseEvent e) { 
            moving = true ;
            int del_x = e.getX() - down_x ,
                del_y = e.getY() - down_y ;
            x = x + del_x ;
            y = y + del_y ;
            // stay shy of right and bottom screen  10/1/2020
              if (x+W > screen_size.width) x = screen_size.width - (W+3) ; // move left
              if (y+H > screen_size.height) y = screen_size.height - (H+3) ; // move up
            setLocation(x,y) ; 
         }
      }) ;   
      // Border for the app
      icon_label.setBorder(new LineBorder(Color.GREEN));
      //icon_label.setBorder(new BevelBorder(BevelBorder.RAISED,Color.GRAY,Color.GRAY));
      //
      this.add(icon_label) ;
      this.x = 20 ; this.y = 30 ; 
      this.setLocation(x,y) ; 
      this.setSize(W,H) ; 
      this.setUndecorated(true) ; 
      this.getContentPane().setBackground(DefaultColor) ; 
      try { // locate where last positioned
         Properties settings = new Properties() ; 
         settings.load(
           new FileInputStream(
            System.getProperty("user.home")+File.separator+"AutoLogApp.settings" )  ) ; 
           x = Integer.parseInt(settings.getProperty("x").trim()) ;
           y = Integer.parseInt(settings.getProperty("y").trim()) ;  
           this.setLocation(x,y) ;
      }
      catch (Exception x) { } 
      // Drop files on the icon_label to open 
      AppDropFileHandler adfhandler = new AppDropFileHandler() ; 
      icon_label.setTransferHandler(adfhandler) ; 
   }

   public static void main(String[] args) { 
      try { 
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()) ; 
         //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName()) ; 
      } catch (Exception x) {}
      AutoLogApp app = new AutoLogApp() ; 
      app.setVisible(true) ;  
      String jarfilename = System.getProperty("user.home") +File.separator+ "colog14I.jar" ;
      //System.out.println(jarfilename) ; 
      File src = new File(jarfilename) ; // N.B. wrong name for test
//      if (!src.exists()) 
//         JOptionPane.showMessageDialog(app,"<html>Put a copy of <b>autologI.jar</b><p> in the directory <tt>"+System.getProperty("user.home"),"Cannot find colog14I.jar",JOptionPane.INFORMATION_MESSAGE) ;
   }
}

/**
  *  AppDropFileHandler opens dropped files
  *  as separate process -- quit would not affect JavApp  
   */
class AppDropFileHandler extends TransferHandler {
   
   /***  Attempt any drop. */
   public boolean canImport(JComponent comp, DataFlavor[] flavor) {
      return true ; 
   }

   /***  Open file in new AutoLogEditor. */
   public boolean importData(JComponent comp, Transferable t) {
      // MAC OSX and Windows
      if (t.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
         try { 
            java.util.List list = (java.util.List)t.getTransferData(DataFlavor.javaFileListFlavor);
            Iterator it = list.iterator() ; 
            while (it.hasNext()) { 
               // Run editor(s) as separate process
               String[] cmdarr = 
                 { "java" , "-cp", 
                    System.getProperty("user.home")+File.separator+"autolog", 
                     "sam.gui.edit.AutoLogEditor", 
                     it.next().toString()  } ;    

               try { Runtime.getRuntime().exec(cmdarr) ; } 
               catch(Exception xx) { System.out.println(xx) ; } 
            }
            return true;
         } 
         catch (Exception xx) { System.out.println(xx) ; }
      }
      // OTHERWISE -- 10/28/2022O --   postpone attempt to open one of the files ... Linux?  
/* 
      // COLOG14I code -- NEED TO MODIFY FOR AUTOLOG 
      DataFlavor[] flavors = t.getTransferDataFlavors() ; 
      int p = -1 ; 
      String s = "java.awt.datatransfer.DataFlavor[mimetype=text/uri-list;representationclass=java.lang.String]" ;
      for(int i = 0 ; i < flavors.length ; i++) {
         //System.out.println(flavors[i].toString()) ; 
         if (flavors[i].toString().startsWith(s)) p = i ;
      }
      if (p == -1) return false ; // or otherwise 
      try { 
         String u = ((String)t.getTransferData(flavors[p])).trim() , 
                v ;
         int k = u.indexOf("localhost") ; // Mac OS X
         if (k > -1) v = u.substring(0,k) + u.substring(k+9,u.length()) ; // snip out
         else v = u ;  
         System.out.println(v) ;
         // Run editor as separate process
         //String command = "java -cp  "+System.getProperty("user.home")+File.separator+"colog14I.jar JavaEditor" ; 
         String command = "java -cp  "+System.getProperty("user.home")+File.separator+"colog14I.jar JavaEditor" ; 
         //System.out.println(command) ;
         try { Runtime.getRuntime().exec(command) ; } catch(Exception xx) { System.out.println(xx) ; } 
         return true ;  
      } catch(Exception x) { System.out.println(x) ; }
*/
      return false ; 
   }
} 

/*
Upon drop, open dialog for process params.
???  or
Somehow elicit dialog to set process params.
???
*/
