
import java.io.* ; 
import java.util.* ; 


/**
  *  Extracting unicode symbols from symbol tables,
  *  generating hex string from chap for 
  *  Dynamic User Operations  -- code experiments
  *  version 19 August 2020
   */
public class DUOP { 

   // N.B. this sourcecode cannot contain «backslash»«u»

   /**
     * echo a file
      */
   public static void echo(File file) { 
      try {
         FileReader fr = new FileReader(file) ;
         BufferedReader br = new BufferedReader(fr) ;
         String line = "" ;  // line of the table 
         while (line != null) {
            line = br.readLine() ;  // the next line
            System.out.println(line) ; 
         }
      } catch (Exception xx) { System.out.println(xx) ; }
   }

   /**
     * Convert antlr's 4-digit hex unicode to char.
      */
   public static char antlrValue(String unicode) { 
      // antlr unicode will have read form  \\u{wxyz},
      // hexcode at positions 3,4,5,6 
      String hexcode = unicode.substring(3,7) ; 
      return (char)Integer.parseInt(hexcode,16);
   }

   /**
     * Convert antlr's 4-digit hex unicode to char. 
     * Format output line similar to input lines. 
      */
   public static String antlrSpec(File f) { 
      try {
         // generate antlr DUOP codes from glyph table
         FileReader fr = new FileReader(f) ;
         BufferedReader br = new BufferedReader(fr) ;
         StringBuffer sbuffer = new StringBuffer() ; 
         String line = "" ;  // line of the table 
         String sym = "";
         //char c = 0 ;
         while (line != null) {
            line = br.readLine() ;  // the next line
            if (line != null) { 
               StringTokenizer tok = new StringTokenizer(line) ; 
                  if(tok.hasMoreTokens())  sbuffer.append("|") ;
                  while (tok.hasMoreTokens()) { 
                     sym = tok.nextToken() ; 
                     sbuffer.append("\'") ;
                     sbuffer.append(sym) ;
                     if(tok.hasMoreTokens()) sbuffer.append("\'|") ;
                     else sbuffer.append("\'") ;
                  } 
                  sbuffer.append("\n") ; 
            }
         }
            return sbuffer.toString() ; 
      } catch (Exception xxx) {System.out.println(xxx) ; } 
      return "" ;
   }


   public static void main(String[] args) {  
      // generate AUTOLOG.g4 DUOP codes

// arrows/greek/ops formatted to paste into AUTOLOG.g4
/*      
      System.out.println("arrows") ;
      System.out.println(DUOP.antlrSpec(new File(System.getProperty("user.home")+File.separator+"autolog/sam/antlr/dev/duop/arrows.txt"))) ;
      System.out.println("greek") ;
      System.out.println(DUOP.antlrSpec(new File(System.getProperty("user.home")+File.separator+"autolog/sam/antlr/dev/duop/greek.txt"))) ;
      System.out.println("ops") ;
      System.out.println(DUOP.antlrSpec(new File(System.getProperty("user.home")+File.separator+"autolog/sam/antlr/dev/duop/ops.txt"))) ;
*/

      //DUOP.echo(new File(System.getProperty("user.home")+File.separator+"autolog/dev/DUOP_redux/AUTOLOG.g4")) ;
      //testing antlrValue unicode ==> char ==> tohexString
      // e.g "_u{22a5}"  on command line,   ___wxyz_
      //char c = DUOP.antlrValue(args[0]) ; 
      //System.out.println(c) ;  
      // antlr hex rep ==> char
      //System.out.println(Integer.toHexString(c)) ; // char ==> he22a5x string 
      //   \ u{2289}  CANNOT REMOVE SPACE and compile

      String s = args[0] ;
      System.out.println(s) ;
      System.out.println(s.codePointAt(0)) ;
      // − (pasted from symbols.txt) is 8722  
      // – (option -)                is 8211  surprise?  
 

   } // end main
}
 
/*

*/
