package sam.gui.search ; 

/////tree     search tree component  (ActiveTree)
/////TP       TreePane Viewer gui component (line 46)

import sam.gui.edit.* ;
import sam.antlr.autolog.* ;  
import sam.machine.lang.* ; 
import sam.machine.engine.* ; // active dev
import sam.machine.active.* ;
import sam.util.* ;

import java.util.* ;
import java.io.* ; 
import java.net.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.awt.datatransfer.* ; 
import javax.swing.* ;
import javax.swing.event.* ;
import javax.swing.plaf.metal.* ;

/**
  *  AutoLog Viewer GUI management 
  *  Revise compile from editor - method setTheoryFromEditor(-)
  *  ATP hashcode SHIFT tool - See  END NOTES
  *  @version 7/11/2023 
  *  «run BLOCKED» warning if !theory.isIndexical
  *  @author &copy; John Fisher
  *  Viewer settings saved upon closing? (√ again later) 
  *  NOTE: URL deprecation warnings at lines 964, 978
   */
public class AutoLog extends JFrame 
                   implements ActionListener, ChangeListener, ListSelectionListener  { 

   private JToolBar toolbar ; 
   public static String BANNER = "AutoLog" ;     
   public static String NOMATCH = " ^ " ;   // bottom rule selection "choice"
   protected Theory theory ;    // loaded from editor
/////tree   protected Tree tree ;  
   protected ActiveTree activeTree ; // construct in setTheoryFromEditor()
   protected String theoryDescription = "" ;
   protected DefaultListModel<String> theoryListModel ;  
   // to left
   protected JTabbedPane tabbedPane ;   // to hold treePane, consoleArea, auxArea 
/////TP   protected TreePane treePane ;
   public JTextArea consoleArea ;       // to show console messages 
   public JTextArea auxArea ;           // auxiliary display (TangleTool uses)
   protected JEditorPane infoPane ;     // info display
   protected URL analyzerURL ;          // Analyzer.html
   protected URL controlURL ;           // Control.html
   protected JList theoryPane ;         // displays compiled theory
   protected Color shade =  
           new Color(250,255,250) ;   // light greenish
   protected JLabel ruleLabel ; 
   protected JButton runButton ;
   protected JMenuItem runMenuItem ;
   protected JMenuItem stopMenuItem ;
   protected JButton clearButton ;
   protected JButton aaButton ; // debug AutoLogAnalyzer
   protected JMenuItem clearMenuItem ;
   protected JScrollPane treeScroller ; 
   protected JSplitPane splitPane ;  
   protected JToggleButton complexityButton ; // term complexity heuristic
   protected JSpinner cspinner ;      // complexity selector
   protected JSpinner SHIFTspinner ;  // << ATPhashcode shift selector for TangleTool, line 871
   protected JLabel boundsLabel ;
   private int keyAccelerator ; 
   private static String fontName = "monospaced" ; 
   private boolean toggle ;
   private int treeDepth ; 
   private int treeWidth ;    
//   private final Vector<Process> processes ; 
//   private final Vector<Boolean> alive ; 
   private static int D = 200 ;
   private static int W = 700 ;
   // GUI window box defaults
      private int x, y, w, h ; 
      private Properties settings ; 
//      private String command ; 
   ///////////////////////////////////
   public AutoLogEditor editor ;  // since 10/18/2017
   public TangleTool tangletool ; // july 2021, TangleTool talks with viewer

   /**
     *  Construct the GUI and event handlers.
     */ 
   public AutoLog(int cpn) { 
      settings = new Properties() ; 
      try { 
         settings.load(
           new FileInputStream(
            System.getProperty("user.home")+File.separator+"AutoLogViewer.settings" )  ) ; 
         this.x = Integer.parseInt(settings.getProperty("x").trim()) ;
         this.y = Integer.parseInt(settings.getProperty("y").trim()) ; 
         this.w = Integer.parseInt(settings.getProperty("w").trim()) ;
         this.h = Integer.parseInt(settings.getProperty("h").trim()) ; 
         //this.command = settings.getProperty("command").trim() ;
      }
      catch(Exception any_trouble) {x = 300 ; y = 150 ; w = 800 ; h = 600 ;  System.out.println(any_trouble) ; } // defaults 
//      command = "java -Xms1g -Xmx1g -jar " + 
//              System.getProperty("user.home") + 
//              System.getProperty("file.separator") +   
//              JARNAME ;  
      /////////////////////////////////
//      processes = new Vector<Process>() ; 
//      alive =  new Vector<Boolean>() ; 
      //System.out.println(System.getProperty("user.dir")) ;
      //System.out.println(System.getProperty("user.home")) ;
      //System.out.println(System.getProperty("user.name")) ;
      //sharedCount = new SharedCount() ; 
      //System.out.println(System.getProperty("os.name")) ; 
      this.treeDepth = D ;    // default
      this.treeWidth = W ;    // same as tree.width 
      this.setTitle(BANNER + theoryDescription) ; 
      // TREE & TREE PANE 
/////tree    tree = new Tree(this.treeDepth,this.treeWidth) ; 
//      activeTree  constructed in setTheoryFromEditor(-)
/////tree    tree.setLogging(true) ;   // logging true when using GUI
//      activeTree.setLog(true) ;    // in setTheoryFromEditor(-)
/////TP      treePane = new TreePane() ;  
/////TP      treePane.setBackground(new Color(200,250,250)) ; 
/////TP      treePane.setCologTree(tree) ; 
/////TP      treeScroller =  
/////TP         new JScrollPane(treePane) ; 
/////TP      treePane.scrollPane = treeScroller ;   // for view dragging  //xxxxx
      // TABBEDPANE
      tabbedPane = new JTabbedPane() ;   
      consoleArea = new JTextArea() ;  
        consoleArea.setToolTipText("<html><font size=\"+0\"><b>console area</b><br> &nbsp;reports for load errors,&nbsp;&nbsp;   <br>&nbsp;system reports, <<br> &nbsp;and search reports.&nbsp;&nbsp;     ") ;
      consoleArea.setBackground(new Color(240,240,240)) ; 
      auxArea = new JTextArea() ;   //xxxxx  
      auxArea.setToolTipText("<html><font size=\"+0\"><b>aux area</b><br> &nbsp;proof reports,&nbsp;&nbsp;   <br>&nbsp;model reports, <br>&nbsp;theory analysis, <br> &nbsp;LaTeX tree picture code.&nbsp;&nbsp;     ") ;
      auxArea.setBackground(new Color(255,245,220)) ; 
      auxArea.setFont(new Font("monospaced",Font.PLAIN,18)) ;
      Class clz = this.getClass() ;    // NEEDS NEW DESIGN, 
      this.analyzerURL = clz.getResource("Analyzer.html") ;
      this.controlURL = clz.getResource("Control.html") ;
      try {
         this.infoPane = new JEditorPane(analyzerURL) ;
      } catch(Exception xxx) { System.out.println(xxx) ; }
      this.infoPane.setBorder(BorderFactory.createMatteBorder(8,8,0,3,shade));
      this.infoPane.setBackground(shade) ; 
//////tabbedPane.addTab("tree", null, treeScroller, "view colog tree") ;       // eventually 
      tabbedPane.addTab("tree", null, new JTextArea(), "view autolog tree") ;  // TEMPORARY
      tabbedPane.addTab("console", null, new JScrollPane(consoleArea), "view autolog console") ; 
      tabbedPane.addTab("aux", null, new JScrollPane(auxArea), "view proof, models, theory analysis, LaTeX code") ; 
      tabbedPane.addTab("? ? ?", null, new JScrollPane(this.infoPane), "view info") ; 

      // LOOK AND FEEL
      try { 
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
         //UIManager.setLookAndFeel(new MetalLookAndFeel()); 
      } catch(Exception x) {}

      this.theoryListModel = new DefaultListModel<String>() ;
      // prevent closing unless requested 
      this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE) ; // see doExit()
      this.setSize(w,h) ; 
      this.setLocation(x,y) ; 

      // Create a menubar 
      JMenuBar mb = new JMenuBar() ; 
      this.setJMenuBar(mb)  ; 
      // RUN menu
      JMenu runMenu = new JMenu("run") ; 
      // RUN  
      runMenuItem = new JMenuItem("Run =>") ; 
      runMenuItem.setForeground(Color.GRAY) ; 
      runMenuItem.addActionListener(this) ;
      runMenuItem.setActionCommand("run") ;
      runMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,InputEvent.META_DOWN_MASK)) ;  
      //runMenuItem.setEnabled(false) ; 
      runMenu.add(runMenuItem) ; 
      // STOP
      stopMenuItem = new JMenuItem("Stop") ; 
      stopMenuItem.setForeground(Color.GRAY) ; 
      stopMenuItem.addActionListener(this) ;
      stopMenuItem.setActionCommand("clear") ;
      stopMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.META_DOWN_MASK+InputEvent.SHIFT_DOWN_MASK)) ;  
      runMenu.add(stopMenuItem) ; 
      // CLEAR  
      clearMenuItem = new JMenuItem("Clear") ; 
      clearMenuItem.addActionListener(this) ;
      clearMenuItem.setActionCommand("clear") ;
      clearMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,InputEvent.META_DOWN_MASK+InputEvent.SHIFT_DOWN_MASK)) ;  
      runMenu.add(clearMenuItem) ; 
      mb.add(runMenu) ; 
      // VIEW 
      JMenu viewMenu = new JMenu("view") ; 
      // TOOLBAR 
      JCheckBoxMenuItem toolbarTextMenuItem = 
           new JCheckBoxMenuItem("Toolbar",true) ; 
      toolbarTextMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,InputEvent.META_DOWN_MASK)) ; 
      toolbarTextMenuItem.addActionListener(this) ;  
      viewMenu.add(toolbarTextMenuItem) ; 
      // ABOUT
      JMenuItem aboutMenu = new JMenu("about") ; 
      JMenuItem controlMenuItem = new JMenuItem("search control") ; 
      controlMenuItem.addActionListener(this) ; 
      controlMenuItem.setActionCommand("about_control") ; 
      aboutMenu.add(controlMenuItem) ;
      JMenuItem analyzerMenuItem = new JMenuItem("theory analyzer") ; 
      analyzerMenuItem.addActionListener(this) ; 
      analyzerMenuItem.setActionCommand("about_analyzer") ; 
      aboutMenu.add(analyzerMenuItem) ;
      viewMenu.add(aboutMenu) ; 
      // SHOW EDITOR     
      JMenuItem show_editor = new JMenuItem("show my editor") ; 
      show_editor.addActionListener(this) ; 
      show_editor.setActionCommand("show_editor") ; 
      show_editor.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,InputEvent.META_DOWN_MASK)) ;  
      viewMenu.add(show_editor) ; 
      viewMenu.addSeparator() ; 
      // TREE SCALE 
      JMenu treescaleMenu = new JMenu("tree view scale") ; 
      treescaleMenu.setForeground(Color.GRAY) ;
      /////
      JMenuItem biggerMenuItem = new JMenuItem("larger +") ; 
/////TP      biggerMenuItem.addActionListener(treePane) ;
      biggerMenuItem.addActionListener(this) ;  // for "orient"
      biggerMenuItem.setActionCommand("larger") ;
      biggerMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.META_DOWN_MASK)) ;  // InputEvent.META_DOWN_MASK
      treescaleMenu.add(biggerMenuItem) ; 
      /////
      JMenuItem smallerMenuItem = new JMenuItem("smaller -") ; 
/////TP      smallerMenuItem.addActionListener(treePane) ;
      smallerMenuItem.addActionListener(this) ;  // for "orient"
      smallerMenuItem.setActionCommand("smaller") ;
      smallerMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,InputEvent.META_DOWN_MASK)) ;  // InputEvent.META_DOWN_MASK
      treescaleMenu.add(smallerMenuItem) ; 
      /////
      JMenuItem fit = new JMenuItem("Scale tree to viewport") ; 
/////TP      fit.addActionListener(treePane) ; 
      fit.addActionListener(this) ;
      fit.setActionCommand("fit") ; 
      fit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.META_DOWN_MASK)) ;  
      treescaleMenu.add(fit) ; 
      /////
      JMenuItem original = new JMenuItem("Original scale") ; 
/////TP      original.addActionListener(treePane) ; 
      original.addActionListener(this) ;
      original.setActionCommand("original") ; 
      original.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,InputEvent.META_DOWN_MASK)) ;  
      treescaleMenu.add(original) ; 
      /////
      /////
      JMenuItem fractionMenuItem = new JMenuItem("50% original") ; 
/////TP      fractionMenuItem.addActionListener(treePane) ;
      fractionMenuItem.addActionListener(this) ;
      fractionMenuItem.setActionCommand("fraction") ;
      fractionMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F,InputEvent.META_DOWN_MASK)) ;  // InputEvent.META_DOWN_MASK
      treescaleMenu.add(fractionMenuItem) ; 
      viewMenu.add(treescaleMenu) ; 
      ///// ZOOM to selected node  -- just moves view, no enlargement
      JMenuItem zoom = new JMenuItem("zoom selected tree node") ; 
      zoom.setForeground(Color.GRAY) ;
      zoom.createToolTip() ; 
      zoom.setToolTipText("<html><font size=\"+0\">move tree view to zoom on selected tree fact") ; 
      zoom.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.META_DOWN_MASK)) ;  // InputEvent.META_DOWN_MASK 
/////TP      zoom.addActionListener(treePane) ; // action goes there, not here
      zoom.setActionCommand("zoom") ;
      viewMenu.add(zoom) ; 
           // original intent was to "zoom" with auto enlarge, no enlarge now
      viewMenu.addSeparator() ; 
      mb.add(viewMenu) ; 

      // AUX menu
      JMenu auxMenu = new JMenu("aux") ; 
      auxMenu.setBackground(new Color(255,255,204)) ; 
      //auxMenu.setOpaque(true);
      //auxMenu.setBorderPainted(false);
      // PROOF
      JMenuItem proof = new JMenuItem("extract proof from tree") ; 
      proof.setForeground(Color.GRAY) ;
      proof.addActionListener(this) ; 
      proof.setActionCommand("proof") ; 
      auxMenu.add(proof) ; 
      // Log COUNTER MODELS 
      JMenuItem cmodels = new JMenuItem("extract counter models from tree") ; 
      cmodels.setForeground(Color.GRAY) ;
      cmodels.addActionListener(this) ;
      cmodels.setActionCommand("cmodels") ;
      auxMenu.add(cmodels) ; 

      //  LaTeX PICTURE code
      JMenuItem latex = new JMenuItem("Generate LaTeX picture code for tree") ; 
      latex.setForeground(Color.GRAY) ;
      latex.addActionListener(this) ;
      latex.setActionCommand("latex") ;
      auxMenu.add(latex) ; 
      auxMenu.addSeparator() ;
      // THEORY ANALYSIS 
      JMenuItem analyze = new JMenuItem("theory analysis") ; 
      analyze.addActionListener(this) ; 
      analyze.setActionCommand("analyze") ; 
      analyze.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,InputEvent.META_DOWN_MASK+InputEvent.SHIFT_DOWN_MASK)) ;  
      auxMenu.add(analyze) ; 
      // MATCH TEST -- FOR DESIGN DEV
      //  sam.machine.engine.MatchTest  for development testing
      JMenuItem match_test = new JMenuItem("match test") ; 
      match_test.addActionListener(this) ; 
      match_test.setActionCommand("match_test") ; 
      match_test.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,InputEvent.META_DOWN_MASK+InputEvent.SHIFT_DOWN_MASK)) ;  
      auxMenu.add(match_test) ; 
      // TANGLE TOOL -- FOR DESIGN DEV
      //  sam.machine.engine.TangleTool  for development testing
      JMenuItem tangle_tool = new JMenuItem("tangle tool") ; 
      tangle_tool.addActionListener(this) ; 
      tangle_tool.setActionCommand("tangle_tool") ; 
      tangle_tool.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,InputEvent.META_DOWN_MASK+InputEvent.SHIFT_DOWN_MASK)) ;  
      auxMenu.add(tangle_tool) ; 
      // JMenuItem query_widget deleted 
      // TABLE INSPECTION DIALOG
      JMenuItem inspect_table = new JMenuItem("inspect fact table") ; 
      inspect_table.setForeground(Color.GRAY) ; 
      inspect_table.addActionListener(this) ; 
      inspect_table.setActionCommand("inspect_table") ; 
      auxMenu.add(inspect_table) ; 
      mb.add(auxMenu) ; 

/////////////////////////////////////////////////////////////////
///// TOOLBAR ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
      toolbar = new JToolBar() ; 
      toolbar.setBackground(shade) ; 

      Class clazz = this.getClass() ; 
      //int fontsize = 24 ; 

      // NAME LABEL
      JLabel nameLabel = new JLabel(" AutoLog Viewer ") ; 
      nameLabel.setFont(new Font(fontName,Font.BOLD,24) ) ; 
      nameLabel.setForeground(Color.BLACK) ; 
      toolbar.add(nameLabel) ;  
      toolbar.add(new JLabel("     ")) ;
      /////
      //RUN button  
      runButton = new JButton("=> ") ; 
      Font runfont = runButton.getFont() ; // Use the system font
      runButton.setFont(new Font(runfont.getFontName(),runfont.getStyle(),16)) ; 
      runButton.setBackground(shade) ; 
      runButton.createToolTip() ; 
      runButton.setToolTipText("<html><font size=\"+0\">   RUN ... build tree  ... ") ; 
      runButton.addActionListener(this) ; 
      runButton.setActionCommand("run") ;
      toolbar.add(runButton) ; 
      // BOUNDS LABEL
      boundsLabel = new JLabel(this.boundsString()) ; 
      toolbar.add(boundsLabel) ; 
      boundsLabel.setMaximumSize(new Dimension(100,30)) ; 
      boundsLabel.addMouseListener(
         new MouseAdapter() {
            public void mouseClicked(MouseEvent e) { showBounds() ;  }
         } ) ;
      boundsLabel.createToolTip() ; 
      boundsLabel.setToolTipText("<html><font size=\"+0\">   Click here to modify depth/width bounds ...") ; 
      /////
      //CLEAR button  
      clearButton = new JButton("clear") ; 
      Font clearfont = clearButton.getFont() ; // Use the system font
      clearButton.setFont(new Font(clearfont.getFontName(),clearfont.getStyle(),16)) ; 
      clearButton.setBackground(shade) ; 
      clearButton.createToolTip() ; 
      clearButton.setToolTipText("<html><font size=\"+0\">      CLEAR tree") ; 
      clearButton.addActionListener(this) ; 
      clearButton.setActionCommand("clear") ;
      toolbar.add(clearButton) ; 
      /////
      toolbar.add(new JLabel("  ")) ;  // separator
      toolbar.addSeparator() ;         // separator
      toolbar.add(new JLabel("  ")) ;  // separator
      /////
      complexityButton = new JToggleButton("cut") ; 
      Font f = complexityButton.getFont() ; // Use the system font
      complexityButton.setFont(new Font(f.getFontName(),f.getStyle(),16)) ; 
      complexityButton.setBackground(shade) ; 
      complexityButton.setForeground(Color.GRAY) ; 
      complexityButton.createToolTip() ; 
      complexityButton.setToolTipText("<html><font size=\"+0\">      CUT function complexity is OFF") ; 
      complexityButton.addActionListener(this) ; 
      complexityButton.setActionCommand("complexity") ; 
      /////
      // CSPINNER
      cspinner = new JSpinner(new SpinnerNumberModel(0,0,50,1)) ; 
      cspinner.createToolTip() ; 
      cspinner.setMaximumSize(new Dimension(50,30)) ; 
      cspinner.setToolTipText("<html><font size=\"+0\">       set max operator nesting depth  ") ; 
      cspinner.addChangeListener(this) ; 
      /////
      toolbar.add(complexityButton) ; 
      //cspinner.setRequestFocusEnabled(false) ;
      toolbar.add(cspinner) ; 
      /////
      toolbar.addSeparator() ;           // separator
      toolbar.add(new JLabel("  ")) ;    // separator
      /////
      toolbar.add(new JLabel("<< ")) ;   
      // SHIFT SPINNER
      SHIFTspinner = new JSpinner(new SpinnerNumberModel(1,1,5,1)) ; 
      SHIFTspinner.createToolTip() ; 
      SHIFTspinner.setMaximumSize(new Dimension(50,30)) ; 
      SHIFTspinner.setToolTipText("<html><font size=\"+0\">    set ATPhashcode << shift value  ") ; 
      SHIFTspinner.addChangeListener(this) ; 
      toolbar.add(SHIFTspinner) ; 
      /////
      //////////////////
      // end TOOLBAR 
      //////////////////

      // RULE LABEL at bottom of window
      ruleLabel = new JLabel("      ") ; 
      ruleLabel.setForeground(Color.BLUE) ; 
      ruleLabel.setFont(new Font(fontName,Font.PLAIN,16) ) ; 
      ruleLabel.createToolTip() ; 
      ruleLabel.setToolTipText("   proposed bindings") ; 
/////TP      treePane.info = ruleLabel ; 
/////TP      treePane.auxArea = this.auxArea ;  // 12.13.2015

      // THEORY PANE
      theoryPane = new JList<String>(theoryListModel) ; 
      //theoryPane.setSelectionForeground(Color.BLUE) ;  // inference ~ blue
      //theoryPane.setSelectionBackground(Color.lightGray) ;  // needs be light
      theoryPane.createToolTip() ; 
      String os = System.getProperty("os.name") ; 
      // modified 9/1/2009
      //if ( true || os.indexOf("Mac") > -1 || os.indexOf("Linux" ) > -1) { 
         theoryPane.createToolTip() ; 
         String about_drop = 
            "<html><font size=\"+0\"><b>COLOG THEORY PANE</b><br>&nbsp;DROP theory here  to open it (" + os + ").<br>" +
            "&nbsp;[n] means n<i>th</i> rule is a queued rule. <br>"+
            "&nbsp;Click rule here to view all inference nodes for the rule in search tree.&nbsp;&nbsp; <br> "    ;   
         theoryPane.setToolTipText(about_drop) ; 
      //}
//      theoryPane.setTransferHandler(new DropHandler()) ; 
      theoryPane.setFont(new Font((os.indexOf("Mac") > -1 ? "monospaced":"monospaced"),Font.PLAIN,18) ) ; 
      theoryPane.setBorder(BorderFactory.createTitledBorder("Autolog theory"));
      ////
      theoryPane.getSelectionModel().addListSelectionListener(this) ;
      JScrollPane theoryScroller = new JScrollPane(theoryPane) ; 
      // Tell treePane about theoryPane for rule selections
/////TP      treePane.rulelist = theoryPane ;
      ///// 
      splitPane = 
         //new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,tabbedPane,theoryScroller) ; //xxxxx
         new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,theoryScroller,tabbedPane) ; //reversed ???
      this.getContentPane().add("North", toolbar) ; 
      this.getContentPane().add("Center", splitPane) ; 
      this.getContentPane().add("South", ruleLabel) ; 
      int halfwit = this.getSize().width/2 ;
      splitPane.setDividerLocation(halfwit) ; // double seems not to work

      this.addWindowListener(new WindowAdapter() { 
         public void windowClosing(WindowEvent e) { 
            doExit() ; // save AutoLogViewer.settings
         }
      }) ; 

      Thread shows = new Thread() { 
         public void run() { 
            setVisible(true) ;
         }
      } ;
      EventQueue.invokeLater(shows); 
      this.toggle = true ;  
      /////
      redirectSystemStreams() ;
   } // end AutoLog constructor


///////////////////////////////////////////////////////////////////

   private String boundsString() { 
      return 
        " bounds" ;   // temp
/////tree        "<html>depth="+String.valueOf(tree.depth) +
/////tree        "<br>width="+String.valueOf(tree.width)  ;
   }

   // Make all compilation/analysis data products appear in console.
   private void updateConsole(final String text) {  
      SwingUtilities.invokeLater(new Runnable() {  
        public void run() {  
          consoleArea.append(text);  
        }  
      });  
   }  

   private void redirectSystemStreams() {  
      OutputStream out = new OutputStream() {  
         @Override  
         public void write(int b) throws IOException { 
            updateConsole(String.valueOf((char) b));  
         }  
   
         @Override  
         public void write(byte[] b, int off, int len) 
                                      throws IOException {  
            updateConsole(new String(b, off, len));  
         }  

         @Override  
         public void write(byte[] b) throws IOException {  
            write(b, 0, b.length);  
         }  
      };  
      System.setOut(new PrintStream(out, true));  
      System.setErr(new PrintStream(out, true));  
   }  
///////////////////////////////////////////////////////////////////

   /**
     *  Update this using the current tree. 
     */
   protected void update() { 
      this.orient() ;
   }

   /**
     *  Orient the tree view so that scrollbars are visible if needed.
     *  The getPreferredSize() method of TreePane needs be 
     *  a little bigger than expected(?).
     */
   protected void orient() { 
/////TP      treePane.setXY() ; // NEEDED because repaint will delay too long
/////TP      treePane.repaint() ; 
      this.wiggle() ; 
   }

   //
   // wiggle the divider, in case scrollbars are needed ;-) kludge 
   //
   protected void wiggle() { 
      this.splitPane.setDividerLocation(splitPane.getDividerLocation() + (toggle?1:-1)) ;
      if (toggle) toggle = false; else toggle = true ; 
      // keep focus in view
/////TP      JScrollBar v = this.treeScroller.getVerticalScrollBar() ,
/////TP                 h = this.treeScroller.getHorizontalScrollBar() ;  
/////TP      Dimension d = treePane.getPreferredSize() ; 
/////TP      v.setValue(d.width) ; 
/////TP      h.setValue(d.height) ; 
   }

   /**
     *  Adjust bounds, and possibly tree. 
      */
   protected void setBounds(int d, int w) { 
      ///////////////////////////////////
      // see colog14I codes if required.
      //////////////////////////////////
   }
   
   // encapsulate bounds inquiry 
   protected void showBounds() {
        Object[] contents = new Object[4] ; 
        contents[0] =  new JLabel("depth") ;  
        contents[1] =  new JTextField() ; 
        contents[2] =  new JLabel("width") ;  
        contents[3] =  new JTextField() ; 
        Object[] options = { "Ok", "Cancel" } ; 
        boolean error = true ;  // loop until same or sensible
        while (error) { 
           ((JTextField)contents[1]).setText(String.valueOf(this.treeDepth)) ; 
           ((JTextField)contents[3]).setText(String.valueOf(this.treeWidth)) ; 
           int result =    
              JOptionPane.showOptionDialog(this ,
                                          contents, 
                                          "    Set Search Bounds    ", 
                                          JOptionPane.DEFAULT_OPTION, 
                                          JOptionPane.QUESTION_MESSAGE,
                                          null, options, options[0]); 

           int d = -1, w = -1 ; 
           try { 
              d = Integer.parseInt(((JTextField)contents[1]).getText()) ; 
              w = Integer.parseInt(((JTextField)contents[3]).getText()) ; 
              error = false ; 
           }
           catch(Exception xx) {} // error ...
           if (d >= 1 && w >= 1) { 
              this.treeDepth = d ; 
              this.treeWidth = w ;
              error = false ; 
           } else error = true ; 
        } // end while(error) 
        this.setBounds(this.treeDepth,this.treeWidth) ; 
   }

   // encapsulate table dialog inquiry 
   protected void tableDialog() {
/*   UNDER DEV
        Object[] contents = new Object[3] ; 
        contents[0] =  new JLabel("<html>Inspect table for") ;  
        contents[1] =  new JTextField() ; 
        ((JTextField)contents[1]).setBorder(BorderFactory.createTitledBorder("branch #")) ;
        contents[2] =  new JLabel("<html>Console Report appears<br> <font color=\"RED\"><i>after</i></font> next run.") ;  
        //contents[3] = new JRadioButton("fact table") ;  
        //contents[4] = new JRadioButton("subfact table") ;
        //ButtonGroup grp = new ButtonGroup() ; 
        //grp.add((JRadioButton)contents[3]) ; 
        //grp.add((JRadioButton)contents[4]) ; 
        //((JRadioButton)contents[3]).setSelected(true) ;
        Object[] options = { "Ok", "Cancel" } ; 
        int b = -1 ; 
        int result =    
              JOptionPane.showOptionDialog(this ,
                                          contents, 
                                          "   Table Inspector    ", 
                                          JOptionPane.DEFAULT_OPTION, 
                                          JOptionPane.QUESTION_MESSAGE,
                                          null, options, options[0]); 

        try { 
           if (result == 0)
              b = Integer.parseInt(((JTextField)contents[1]).getText()) ; 
        }
        catch(Exception xx) {  ; } 
        //System.out.println(b) ; 
        if (b > 0) {
/////tree           tree.atLeaf = b ; 
           System.out.println("Inspect table for branch #"+b+" f=factual s=subfactual") ; 
        }
        else  { 
/////tree           tree.atLeaf = -1 ;
           System.out.println("No table inspection." ) ; 
        }
*/
      auxArea.setText("Table inspector under development...") ; 
      tabbedPane.setSelectedIndex(2) ;
   }

   /**
     *  Actions.
     */
   public void actionPerformed(ActionEvent e) { 
      String command = e.getActionCommand() ; 
      // System.out.println(command) ;       
      if (command.equals("Toolbar")) {
         if (toolbar.isVisible()) { 
            toolbar.setVisible(false) ; 
         }
         else { 
            toolbar.setVisible(true) ; 
         }
      }   
      ////
//      else if (command.equals("open")) open() ; 
/*
      else if (command.equals("reload")) {
         if (!theoryDescription.equals(""))  // no current
            open(theoryDescription) ; 
      }
*/
      else if (command.equals("openURL")) {   
         Object[] contents = new Object[3] ; 
         contents[0] =  new JLabel("enter, drop or paste URL:                            ") ;  
         contents[1] =  new JTextField() ; 
         contents[2] =  new JLabel("colog will attempt to load this theory ...") ; 
         Object[] options = { "Ok", "Cancel" } ; 
         int result =    
            JOptionPane.showOptionDialog(this ,
                                       contents, 
                                       "    Open URL    ", 
                                       JOptionPane.DEFAULT_OPTION, 
                                       JOptionPane.QUESTION_MESSAGE,
                                       null, options, options[0]); 
         if (result == 0) { 
            String input = ((JTextField)contents[1]).getText() ;
            if (!input.equals("")) open(((JTextField)contents[1]).getText()) ;
         }
      } 
      else if (command.equals("latex")) latex() ;
      else if (command.equals("cmodels")) cmodels() ;
      else if (command.equals("analyze")) analyze() ;
      else if (command.equals("match_test")) match_test() ; 
      else if (command.equals("tangle_tool")) tangle_tool() ; 
      else if (command.equals("run")) { 
         ruleLabel.setText("      ") ; // does not clear text first (√ later)
         if (!this.theory.isIndexical()) {
            System.out.println(" AT PRESENT, WE CANNOT RUN A NON-INDEXICAL PROGRAM. ") ;
            // Also create a JDialog to get user's attention
              JDialog warning =  new  JDialog (this ) ; 
              warning. setTitle ( " run BLOCKED " ) ; 
              warning. setSize( 210,75 ) ; 
              warning. setModal(true) ; // keep user's attention
              warning.add(new JLabel("  The program is NOT indexical. ")) ; 
              warning.setVisible(true) ; 
         } // end messages to Viewer user re non-indexicality of program
         // else run activeTree 
      }
      else if (command.equals("clear")) { 
         this.clear() ; 
         ruleLabel.setText("      ") ; 
      }
      else if (command.equals("about_control")) {  
         try { 
            this.infoPane.setPage(this.controlURL) ;
         } catch(Exception xx) { System.out.println(xx) ; }
         tabbedPane.setSelectedIndex(3) ;         
      }
      else if (command.equals("about_analyzer")) { 
         try { 
            this.infoPane.setPage(this.analyzerURL) ;
         } catch(Exception xx) { System.out.println(xx) ; }
         tabbedPane.setSelectedIndex(3) ;         
      }
      else if (command.equals("bounds")) {  
/////tree        this.showBounds2() ;   
      } 
      else if (command.equals("proof")) { 
            //DataWindow proofWindow = new DataWindow() ; 
            //proofWindow.setLocation(400,400) ; 
            //proofWindow.setSize(600,400) ; 
            //proofWindow.setTitle("Proof") ; 
/////tree            auxArea.setText(this.theoryDescription+"\n"+this.tree.proof()) ; 
            //proofWindow.setVisible(true) ; 
            auxArea.setText("Extract proof under development...") ; 
            tabbedPane.setSelectedIndex(2) ; 
      }
/*
      else if (command.equals("new")) {  
         File src = new File(System.getProperty("user.dir")+File.separator+JARNAME) ; // N.B. wrong name for test
         System.out.println(src) ;
         if (!src.exists()) 
            JOptionPane.showMessageDialog(this,"<html>Put a copy of <b>"+JARNAME+"</b><p> in the directory <tt>"+System.getProperty("user.home"),"Cannot find "+JARNAME,JOptionPane.INFORMATION_MESSAGE) ;
         else {
            this.newCologProcess() ; 
         }
      }
*/
      else if (command.equals("complexity")) {  
         if (complexityButton.isSelected()) {
/////tree            tree.complexity_limit = ((Integer)cspinner.getValue()).intValue() ;
            complexityButton.setToolTipText("<html><font size=\"+1\">        CUT function complexity is ON") ;
            complexityButton.setForeground(Color.RED) ; 
            complexityButton.setBackground(Color.WHITE) ; 
         }
         else {
/////tree            tree.complexity_limit = -1 ; // OFF
            complexityButton.setToolTipText("     CUT function complexity is OFF") ;
            complexityButton.setForeground(Color.GRAY) ; 
         }
      }
      else if (command.equals("inspect_table")) { tableDialog() ;  }
      else if (command.equals("show_editor")) { this.editor.setVisible(true) ;  }
      else this.orient() ; 
      /////
   }  // end actionPerformed

   public void stateChanged(javax.swing.event.ChangeEvent e) { 
/////tree      if (complexityButton.isSelected())
/////tree         tree.complexity_limit = ((Integer)cspinner.getValue()).intValue() ;
   }

   /**
     *  Clear the tree.
     */
   protected void clear() { 
      // initialize tally array 
/////TP      treePane.setSelected(-1) ; // de-select actually 
      //treePane.dw.setVisible(false) ; 
/////tree      tree.clear() ; 
      this.auxArea.setText("") ; // 
      this.consoleArea.setText("") ; // 29 May 2014
      this.update() ;
   }

   /**
     *  Generate LaTex for picture tree
     */
   protected synchronized void latex() {
/////TP
/*
      //File f = new File(theorySpec.getAbsolutePath() + ".tex") ; 
      LaTeXTree latextree = new LaTeXTree(this.treePane) ; 
      // inquire regarding x offset for tree
      String s = 
         JOptionPane.showInputDialog(this,"Tree x-offset (Cancel uses offset=0): ", "0") ;
      int xoff = 0 ;            
      try{ 
         xoff = Integer.parseInt(s) ; 
      }
      catch (Exception xxx) { System.out.println(xxx) ; }
      latextree.xoffset = xoff ;  // 0 if there was some error
      if (!theoryDescription.equals(""))
         auxArea.setText(latextree.laTeX(theoryDescription)) ;
*/
      auxArea.setText("LaTeX tree under development ... ") ;
      tabbedPane.setSelectedIndex(2) ; 
   } // end latex()

   /**
     *  Write counter model(s) to auxArea
     */
   protected synchronized void cmodels() { 
/////tree      if (tree.counterModels == null || tree.counterModels.isEmpty()) 
/////tree         auxArea.setText("No counter models") ; 
/////tree      else auxArea.setText(tree.reportCounterModels()) ;
      auxArea.setText("Extract counter models under development...") ;
      tabbedPane.setSelectedIndex(2) ; 

   } // end cmodels()



   /**
     *  Write AutoLog theory analysis to auxArea
     */
   protected synchronized void analyze() { 
      if (this.theory.size() == 0) {  // mod 2/9/20 
         auxArea.setText("No theory loaded.") ; 
      } 
      else {
         AutoLogAnalyzer.analyze(this.theory) ;
         auxArea.setText(this.theoryDescription+"\n"+AutoLogAnalyzer.report(this.theory)) ; 
         auxArea.setCaretPosition(0) ; 
      } 
      tabbedPane.setSelectedIndex(2) ; 
   }

   /**
     *  Write AutoLog match test to auxArea
     */
   protected synchronized void match_test() { 
      StringBuffer buffer = new StringBuffer() ; 
      // check to see if possibly a match problem
      boolean check = (this.theory.size() > 0) && 
                      (this.theory.elementAt(0) instanceof Rule) ;  
      if (check) {  // 'match', fact, literal => result.
         Rule r = (Rule)this.theory.elementAt(0) ; 
         check = (r.antecedent.size() == 3)  && 
                 (r.antecedent.elementAt(0).name != null) &&
                 (r.antecedent.elementAt(0).name.equals("match")) && 
                 (r.consequent.size() == 1) && 
                 (r.consequent.elementAt(0).size() == 1) ;      
      } 
      if (check) { // seems to be a match test
         Rule r = (Rule)this.theory.elementAt(0) ;
         Term fact = r.antecedent.elementAt(1) ;
         Term literal = r.antecedent.elementAt(2) ;
         Term result = r.consequent.elementAt(0).elementAt(0) ;
         buffer.append("Match fact= "+fact.toString()+" with literal= "+literal.toString()+", and\n") ; 
         buffer.append("then substitute match bindings into \nresult = "+result.toString()+".\n") ; 
         MatchTest matchtest = new MatchTest(r) ; 
         boolean test = true ; // was temporary failure state, change to true  later
         Term ret = null ; 
         try {  
            ret = matchtest.match(fact,literal,result) ; 
         } catch (Exception xx) { 
            buffer.append(xx.toString()) ;
            test = false ;  // match failed
         } 
         buffer.append(matchtest.report()+"\n") ; 
         if (test) { 
            if (ret == null) buffer.append("MATCH FAILED. \n") ;
            else { 
               buffer.append("Match attempt completed. \n") ;
               // buffer.append("Substituted result is pending...\n") ;
               buffer.append("After substitution from match,\nresult is "+ ret +".\n") ; 
               buffer.append(matchtest.inspect((Functor)ret)) ; 
               ///// testing result after substitution -- added  4/27/2022
               buffer.append("\n{result itself is still "+ result +"}\n") ;
               ///// substitution is a copy
            }
         }
      }
      else {
         buffer.append("No match problem given.\n") ; 
         buffer.append("example:\n") ; 
         buffer.append("   match, p(a)(b), P(X) => P(a,X).\n") ; 
         buffer.append("{  match, fact, literal => result.\n") ; 
         buffer.append("   match fact with literal \n") ; 
         buffer.append("        return result substituted } \n") ; 
      }
      auxArea.setText(buffer.toString()) ;
      auxArea.setCaretPosition(0) ; 
      tabbedPane.setSelectedIndex(2) ;  //2
  } 

   /**
     *  Create a tangletool for a branch using 
     *     an appropriate compiled theory.
     *  See notes in sam.machine.engine.TangleTool sourcecode.
       */
   protected synchronized void tangle_tool() { 
      StringBuffer buffer = new StringBuffer() ; 
      if (TangleTool.check(this.theory)) {
         int shift = ((Integer)SHIFTspinner.getValue()).intValue() ;
         System.out.println("SHIFTspinner int value="+shift) ; // console?
         this.tangletool = new TangleTool(this.theory,shift) ; // 
         auxArea.setText( this.tangletool.showTest()) ;   // branch and query
         tabbedPane.setSelectedIndex(2) ;                  // select aux &then
         this.tangletool.showQueryWidget(this) ;           // query widget
      }
      else {
         buffer.append("The input does not generate a tangle problem.") ;
         auxArea.setText(buffer.toString()) ;
         auxArea.setCaretPosition(0) ; 
         tabbedPane.setSelectedIndex(2) ;  // aux
      }
   } 

   /**
     *  Add theory to DefaultListModel (and 'no match' item).
     *  Mark nonindexical inferences.
     */
   protected void setTheoryList(Theory theory) {
      this.theoryListModel.clear() ; 
      Iterator it = theory.iterator() ; 
      int c = 1 ; 
      while (it.hasNext()) {  //  ...
         String X = " ↯ " ;    // † ‡
         Inference inference = (Inference)it.next() ;
         // type cast inference (somewhat inconvenient)
         if (inference instanceof Rewrite) inference=(Rewrite)inference ;
         else inference=(Rule)inference ; 
         String infr = inference.toString() ;
         if (!inference.isIndexical()) infr += X ;  // NOT indexical inferences marked with ↯
         this.theoryListModel.addElement(c+" "+ infr) ; 
         c++ ;
      }
      // add bottom-out choice
      this.theoryListModel.addElement(NOMATCH) ; 
   }

   /**
     *  Before exit ...
     *  Changes are not closely tracked.
     *  Exiting means invisibility only.    
     */
   public void doExit() {    
         Point p = this.getLocation() ; 
         settings.put("x",String.valueOf(p.x)) ; 
         settings.put("y",String.valueOf(p.y)) ; 
         Dimension d = this.getSize() ; 
         settings.put("w",String.valueOf(d.width)) ; 
         settings.put("h",String.valueOf(d.height)) ; 
         //settings.put("command",this.command) ; 
         try { 
            FileOutputStream fos = 
               new FileOutputStream(
                 System.getProperty("user.home")+File.separator+"AutoLogViewer.settings") ; 
            settings.store(fos, "AutoLogViewer user properties") ; 
         }
         catch(Exception x) {  
            System.out.println(x) ; 
         }
         this.setVisible(false) ; 
   }   

   /**
     *  GUI from the command line.
     */
   public static void main(String[] args) { 
         //System.out.println(args.length) ;
         AutoLog gui = new AutoLog(0) ; 
         if (args.length == 1) gui.open(args[0]) ;
         // e.g., args[0].equals  file:/colog14G/co/dpe.gl
   }

   // a work-around for Java 1.8  ?
   private static String url(String s) { 
      try { 
         return new URL(s).toString() ;  // deprecated by Java20
      }
      catch (Exception x) {
         return "file:"+s ; 
      }
   }

   /**
     * open theory linked to url
     */
   public void open(String U) {  // can be called via command-line
      tabbedPane.setSelectedIndex(0) ;  // show console
      URL url = null ;
      try { 
         url = new URL(U) ; // deprecated by Java20
      }
      catch (Exception mue) { 
         System.out.println(mue) ;  // see console
         JOptionPane.showMessageDialog(this,
             "<html><b>Bad drop<br>See colog Console for report.") ; 
      }
      if (url == null) return ; // leave GUI as was 
      // get url
      Theory xtheory = null ; // null return if exception 
      boolean trouble = false ;
      try { 
         InputStream in = url.openStream() ; 
         xtheory = sam.antlr.autolog.Compiler.translate(in) ; 
         in.close() ;
      }
      catch (Exception x) { 
         trouble = true ; 
      }
      if (trouble) { 
         JOptionPane.showMessageDialog(this,
             "<html><b>Load errors<br>See console.") ; 
         return ; // leave current theory alone
      }
      // otherwise install new xtheory
      // clear all displays
      this.clear() ; 
      this.consoleArea.setText("") ; 
      //this.tree.clear() ; 
      //this.setTitle("Autolog") ; 
      this.theoryListModel.clear() ; 
      this.ruleLabel.setText("   ") ; 
/////TP      this.treePane.selected =  -1 ; // de-select
      this.theory = xtheory ;
      this.theoryDescription = url.toString() ;
      this.setTitle(BANNER + this.theoryDescription) ; 
/////tree      tree.setTheory(this.theory) ; 
      this.setTheoryList(this.theory) ;
      this.update() ; 
   }

   /**
     *  Rule use display in tree.  Inner class.
     *  Still not as originally intended, but nice this way ;-)
     *  1st click on tree node highlights all nodes using inference rule, 
     *  2nd click limits to just the particular tree node - nice.
      */
   public void valueChanged(ListSelectionEvent e) {
/////TP      treePane.rule = theoryPane.getSelectedIndex()+1 ;
/////TP      treePane.selected = -1 ; 
/////TP      treePane.repaint() ; 
   }

   /**
     *  Message from AutoLogEditor.
     *  NOTE that redirectSystemStreams() will send 
     *  ALL compilation products to the console!   
     *  @version 4/29/2023
      */
   public void setTheoryFromEditor(InputStream in) { // via compile action from editor
      tabbedPane.setSelectedIndex(0) ;
      boolean trouble = false ;
      Theory thy = null ;
      try {   
         thy = sam.antlr.autolog.Compiler.translate(in) ; 
         in.close() ;  
      }
      catch (Exception x) {
         System.out.println(x) ;
         trouble = true ;  
      }
      if (trouble) { 
         JOptionPane.showMessageDialog(this,
             "<html><b>Load errors<br>See console.") ; 
         return ; // leave current theory alone
      }
      // otherwise install new xtheory
      // clear all displays
      this.clear() ; 
      this.consoleArea.setText("") ; 
      //this.tree.clear() ; 
      //this.setTitle("Colog") ; 
      this.theoryListModel.clear() ; 
      this.ruleLabel.setText("   ") ; 
/////TP      this.treePane.selected =  -1 ; // de-select
      this.theory = thy ;
      //this.theoryDescription = "  AutoLog Analyzer        \n" ;  // TEMPORARY
      //this.setTitle(BANNER + this.theoryDescription) ; 
      this.setTitle("AutoLog Theory from Editor") ; // 11/25/2018 
/////tree      tree.setTheory(this.theory) ; 
      this.analyze() ;  // check theory.isIndexical() before constructing active components
      this.activeTree = new ActiveTree(this.theory,this.treeDepth,this.treeWidth,true) ; 
                                                                         //  log  ^
      this.setTheoryList(this.theory) ;
      this.update() ; 
      consoleArea.setText("See Analyzer report in the AUX pane \n") ;
      tabbedPane.setSelectedIndex(1) ;  // SHOW ^ and then any delayed parse warnings
    }
    // setTheoryFromEditor needs to return before parse errors in 
    //    sam.antlr.autolog.Compiler.translate(in) are written to console.

} // end AutoLog

/* END NOTES
7/28/2022 - 
  - When complexity selection is implemented, need to check that value used is shown on 
    the cspinner.
  - When << shift  selection is implemented, need to check that value is accessable
    to TangleTool.  See tangle_tool() method above
 
*/

     
     
 
