package sam.machine.active ;

import sam.machine.lang.* ;

/**
  * ActiveRewrite motivated by concurrent test prototype
  *     sam.machine.engine.ActiveMod 
  * @version 10/21/2023: Binding and Matching methods
  *    ActiveTree, ActiveTheory, ActiveRule, ActiveRewrite 
  *    all SHARE instance variable theory, and thus can
  *    access AA data via reference "this.theory". 
   */
public class ActiveRewrite extends ActiveInference {
                 //  implements Runnable ^
   public ActiveTree tree ;  // inference manager 
   public Theory theory ;    // access AA data via theory 
   public Rewrite rewrite ;  // static source rewrite
   public boolean dynamic ;  // asserted to tree.BRANCH by an ActiveRule
   public int atFact ; // tree.BRANCH fact# if dynamic
   public Term Lterm, Rterm ; 
   public int index ; // input-program-order if static 
                      // 0 if dynamic, use atFact location instead
   /** 
     * Construct new static ActiveRewrite corresponding  
     * to program source Rewrite.
      */
   public ActiveRewrite(Rewrite rewrite,ActiveTree tree) {      
      this.tree = tree ; 
      this.theory = tree.theory ;
      this.rewrite = rewrite ;
      this.dynamic = false ;  // "static" rewrite
      this.Lterm = rewrite.Lterm ; 
      this.Rterm = rewrite.Rterm ;
      this.index = rewrite.index ;  // source program index
   } 

   /** 
     * Construct new dynamic ActiveRewrite corresponding  
     * to dynamically generated ground equality fact.
      */
   public ActiveRewrite(int indx, Functor left, Functor right, ActiveTree tree) { 
      this.tree = tree ; 
      this.dynamic = true ; // generated by fact left=right
      this.atFact = indx ;  // tree.BRANCH[indx] of the eq fact
         // Use this.atFact value to decide whether this
         // active rewrite is still relevant on a new branch
      this.Lterm = left ;
      this.Rterm = right ;
      this.index = 0 ;    
   } 
 
   public void run() { 
     // under construction 
   }

}     


