package sam.machine.active ;

import sam.machine.lang.* ;

/**
  * ActiveRule using distributive choices methodology 
  * and fact tabeling
  * @version 10/16/2023: Binding and Matching methods
  *    ActiveTree, ActiveTheory, ActiveRule, ActiveRewrite 
  *    all SHARE instance variable theory, and thus can
  *    access AA data via reference 'this.theory'. 
  * @author &copy; John Fisher
   */
public class ActiveRule extends ActiveInference { 
   //         implements Runnable ^
   public ActiveTree tree ;  // inference manager
   public Theory theory ;    // access AA data via theory
   public Rule rule ; // the interpreted lang.Rule 
   public int index ; // program index, for proof reference
   // this.dynamic == false  -- by default 

   /** 
     * Construct new ActiveRule corresponding  
     * to source rule.
      */
   public ActiveRule(Rule rule,ActiveTree tree) { 
      this.rule = rule ; 
      this.tree = tree ;
      this.theory = tree.theory ;
      // this.index set by ActiveTheory
      // this.dynamic is always false for ActiveRule 
   } 
 
   public void run() { 
     // under construction
   }

}

/* End notes
   - See Colog14I:sam.infer.ActiveRule.java re how
     to set up the Variable bindings table. 
   - Also consult  ActiveDCRule.java, ActiveTabDCRule.java
     re DC and tabulation of facts. 
   - Attempt to streamline literal matching methods for 
     predicative theories.
*/
