
package sam.machine.engine ;  
// --release 19 --enable-preview < compile switches
//  --enable-preview             < run switch
//  This file was archived in activeMODdev, 
//  and is no longer executable


import sam.machine.lang.* ; // Theory.translate(String)
import java.util.* ;
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.time.Duration;
import java.time.Instant;
import java.util.concurrent.TimeUnit;

/**
  * Concurrent Java19 Rewrite Loom Test based on 
  * TangleTool rewrite calculations. Run versions for 
  * threadpool and virtual thread ExecutorServices.
  * @version 12/17/2022 preliminary, 
  *    Run exceptions sometimes ... but archived-as-is! no compile or run
  *    Needed reformulation: See INSTEAD sam/machine/engine/ActiveMod.java
   */
public class RLTprelim {

   public static void main(String[] args) 
                 throws InterruptedException { 
      // data
      String MODTest = 
         "true => p(f(1,2),f(2,3)). f(X,Y)=X." ;   //g(X,Y,X)
      Theory theory = 
         sam.machine.lang.Theory.translate(MODTest) ;
      AutoLogAnalyzer.analyze(theory) ;
      Functor fact =
        ((((Rule)theory.elementAt(0)).consequent).elementAt(0)).elementAt(0)  ;
      Rewrite r = (Rewrite)theory.elementAt(1) ; 
      Functor left = (Functor)r.Lterm ; // cast
      Term    right = r.Rterm ;
      // Display the MODTest
      System.out.println("MODTest: ") ; 
      System.out.println(theory) ;  
      boolean[] key = left.key ;  
      System.out.println("Lterm key profile="+TangleTool.string(key)+"\n") ; 
      System.out.println("Rewrite Variable index: "+r.varindex +" \n") ; 
      //-------------- borrow Tangletool ModTest methods/arguments ------------------
      Vector<Integer> path = new Vector<Integer>() ;
      path.add(1) ;
      Functor[] varbind = new Functor[r.U] ; 
      Vector<Vector<Integer>> locs = new Vector<Vector<Integer>>() ;
      Vector<Functor[]> bindings = new Vector<Functor[]>() ;
      TangleTool.locate(left,r.U,fact,path,locs,bindings) ; //task  
      // reports ...
      // ----- describe method -----
      StringBuffer buf = new StringBuffer() ;  
//System.out.println(locs.size()) ;
      buf.append("Describe subterm locations for [1]"+fact+"\n") ; 
      StringBuffer bfr = new StringBuffer() ;
      TangleTool.describe(fact, path, bfr) ;    
      bfr.append("-----------------\n\n") ;
      buf.append(bfr) ;
      /////
      buf.append("# match locations="+locs.size()+"\n") ;
      buf.append("Locations, bindings and modulants: \n") ;
      for (int i=0 ; i<locs.size() ; i++) {
         Functor lterm = (Functor)TangleTool.substitute(left,bindings.elementAt(i)) ;
         Functor rterm = (Functor)TangleTool.substitute(right,bindings.elementAt(i)) ; 
         Vector<Integer> rpath = locs.elementAt(i) ; // replacement path
         /////  modulate
         Functor modulant =(Functor)TangleTool.modulate(fact,0,rpath,rterm) ;
         /////                                         ^ fixed
         buf.append("@"+rpath+":") ;
         buf.append("\n") ;
         buf.append("  "+lterm+" = "+rterm+"\n") ;
         /////  modulation
         buf.append("modulant= "+modulant+"\n") ;
         buf.append("{ fact= "+fact+" }\n") ;
         /////
         buf.append("-----------------\n");
      }
      System.out.println(buf.toString()) ; // Show accumulated MODTest calculations

      //------------------------------------------------------------//    
      //                        LOOM                                //
      //------------------------------------------------------------//    
      // Announce LoomTest
      int number_of_rewrites = 3000 ;  // EDIT
      System.out.println("LoomTest: ") ;
      System.out.println("  Apply rewrite "+left+"="+right+" to " +fact) ;
      System.out.println("  "+number_of_rewrites+" times concurrently:") ;
      System.out.println("  Wait for experiment to terminate ...") ;

      Runnable task = () -> { 
         try {
               //Vector<Integer> path = new Vector<Integer>() ;
               //path.add(1) ;
               //Functor[] varbind = new Functor[r.U] ; 
               //Vector<Vector<Integer>> locs = new Vector<Vector<Integer>>() ;
               //Vector<Functor[]> bindings = new Vector<Functor[]>() ;
            TangleTool.locate(left,r.U,fact,path,locs,bindings) ;  
            int numMods = 0 ;
            for (int i=0 ; i<locs.size() ; i++) {
               //Functor lterm = (Functor)TangleTool.substitute(left,bindings.elementAt(i)) ;
               Functor rterm = (Functor)TangleTool.substitute(right,bindings.elementAt(i)) ;
               Vector<Integer> rpath = locs.elementAt(i) ; // replacement path
               /////  modulate
               Functor modulant =(Functor)TangleTool.modulate(fact,0,rpath,rterm) ;
               numMods++ ; 
            }   
            //System.out.println(numMods) ;
          } 
          catch (Exception X) { System.out.println("@1"+X) ; }          
          //System.out.println(".");        
      } ;  
      /////
      Instant start = Instant.now();
      
      //CHOOSE ONE: 
      //try (var executor = Executors.newFixedThreadPool(200)) {         // POOL
      try (var executor = Executors.newVirtualThreadPerTaskExecutor()) { // VIRTUAL
         for(int i = 1; i < number_of_rewrites; i++) {  /// <<< 
            executor.submit(task);
         }
      }
      catch (Exception e) { 
         System.out.println(e);  // InterruptedException, ExecutionException
      }

      //executor.shutdown() ; 
      Instant finish = Instant.now();
      long timeElapsed = Duration.between(start, finish).toMillis();  //in millis
      System.out.println("Total elapsed time : " + timeElapsed);

      for (int i=0 ; i<10; i++) 
         System.out.print(i) ;
   } // end main


} // end RewriteLoomTest


/* 
      //CHOOSE ONE: 
      //try (var executor = Executors.newFixedThreadPool(100)) {         // POOL
      try (var executor = Executors.newVirtualThreadPerTaskExecutor()) { // VIRTUAL
         for(int i = 1; i < number_of_rewrites; i++) {  /// <<< 
            executor.submit(task);
         }
      }
      catch (Exception e) { 
         System.out.println(e);  // InterruptedException, ExecutionException
      }



*/
