
package sam.machine.lang ;  

/**
  * AutoLog abstract Inference component  
  * Super for static Rewrite or Rule
  *   @version 9/7/2021
   */
public abstract class Inference { 
   public int index ; // set by AutoLogAnalyzer
   public String annotation ; // comments on Rule or Modulator 
   public abstract String toString() ; 

   /** 
     *  Applies for Rule or static Rewrite modulator.
     *  (DynamicActiveRewrite will be automatically indexical.) 
     *  For AUATOLOG22, deep indexicality is REQUIRED for RUN.
      */
   public abstract boolean isIndexical() ;  
   public abstract boolean isPredicative() ;  
   public abstract boolean byName() ;  


}

/* 
   This is an example of a union type.
   Rewrite ≤ Inference
   Rule ≤ Inference  
   Inference = Modulator ∪ Rule
   Theory = Vector<Inference>
   Test kind of inference using 'instanceof' java-op.
   
   related to "AutoMod" ideas in BLAST2018 talk,
   but with terminolog "rewrite" rather than 
   "modulator".
*/
