package sam.machine.lang ; 


/**
  *  AutoLog Variable
  *  @version 5/18/2018
   */
public class Variable extends Term {

   // name, index, arity inherited from Term
   
   /**
     *  Construct AutoLog Variable by name.
     *  The input name for the Variable is its display name.
     */
   public Variable(String name) {
      this.name = name ;
      this.arity = 0 ;
      this.index = -1 ; // 5/18/2018 default (to test), set by AutoLogAnalyzer
   }

   /**
     *  String representation of this Variable. 
      */
   public String toString() { 
      return this.name ;  
   }

   /***
      *  equals by .name
      *  tableing by index 
       */
   public boolean equals(Object obj) { 
      if (!(obj instanceof Variable)) return false ; 
      return (this.name).equals(((Variable)obj).name) ; 
   }

   /***
      *  hash code per equals
       */
   public int hashCode() { 
      return this.name.hashCode()  ; 
   }

   /**
     *  test stub 
     */
   public static void main(String[] args) { 
      Variable x1 = new Variable("X") ;
      Variable x2 = new Variable("X") ;
      System.out.println(x1.equals(x2)) ; 
      System.out.println(x1.name.equals(x2.name)) ; 
   }

}
