package sam.util ;
// UNEMPLOYED SO FAR
import java.util.* ;
import sam.machine.lang.* ;


/**
  * PredicateRecord stores information about
  * predicative literal Functor(s) that appear in a
  * sam.machine.lang.Theory. The purpose is
  * to record predicative information about
  * a theory (name,arity,type) in order to detect
  * names associated with multiple arities or
  * multiple types and to generate WARNINGs
  * regarding names in user source code. Note 
  * that predicative parametric literal functors are
  * also included in PredicateRecord.
   * @version 8/24/2020 (see calendar re DUOPs ???)
   */
public class PredicateRecord { 
   Theory theory ;  // for which 
   HashMap<String,Vector<Integer>> arityMap ;
   HashMap<String,Vector<Byte>>    typeMap ;

   public PredicateRecord(Theory theory) {
      this.theory = theory ;
      this.arityMap = 
        new HashMap<String,Vector<Integer>>() ;
      this.typeMap = 
        new HashMap<String,Vector<Byte>>() ;
   }

   /**
     *  Add name/arity/type to this NameRecord.
     *  name refers to either .name for a named literal
     *  or .toString( ) of .fnctr for a predicative
     *  parametric literal Functor. 
      */  
   public void add(String name, int arity, byte type) { 
      // arity 
      Vector<Integer> abucket = arityMap.get(name) ; 
      if (abucket==null) { 
         Vector<Integer> v = new Vector<Integer>() ; 
         v.add(arity) ;
         arityMap.put(name,v) ; 
      } 
      else if (abucket.contains(arity)) { ; } 
      else abucket.add(arity) ;
      // type 
      Vector<Byte> tbucket = typeMap.get(name) ; 
      if (tbucket==null) { 
         Vector<Byte> v = new Vector<Byte>() ; 
         v.add(type) ;
         typeMap.put(name,v) ; 
      } 
      else if (tbucket.contains(type)) { ; } 
      else tbucket.add(type) ;
   } 
      
   /**
     *  Generate WARNING of multiple arity or type
     *  for the same name.
      */  
   public String warn() {
      StringBuffer sb = new StringBuffer() ; 
      boolean warnings = false ; // none yet
      // for Functor arity 
      Set<String> akeys = this.arityMap.keySet() ; 
      Iterator akeyiterator = akeys.iterator() ;
      while (akeyiterator.hasNext()) {  
         String name = (String)akeyiterator.next() ; 
         Vector<Integer> vec = this.arityMap.get(name) ; 
         if (vec.size() > 1) {  
            // this name associated with multiple arities
            warnings = true ;
            Iterator vecit = vec.iterator() ;
            while (vecit.hasNext()) { 
               int a = (int)vecit.next() ; 
               sb.append(name+" occurs with arity="+ a +"\n") ;
               //if (vecit.hasNext()) sb.append("\n") ;
            } 
         }
      } 
      // sb.append("\n") ;
      // for Functor type
      Set<String> tkeys = this.typeMap.keySet() ; 
      Iterator tkeyiterator = tkeys.iterator() ;
      while (tkeyiterator.hasNext()) {  
         String name = (String)tkeyiterator.next() ; 
         Vector<Byte> vec = this.typeMap.get(name) ; 
         if (vec.size() > 1) {  
            // this name associated with multiple arities
            warnings = true ;
            Iterator vecit = vec.iterator() ;
            while (vecit.hasNext()) { 
               byte a = (byte)vecit.next() ; 
               sb.append(name+" occurs with type="+ a +"\n") ;
               // if (vecit.hasNext()) sb.append("\n") ;
            } 
         }
      }       
      String s = sb.toString() ; 
      if (!sb.equals("")) return "WARNING:\n"+sb.toString() ; 
      else return s ;
   }

   public String toString() { 
      StringBuffer sb = new StringBuffer() ; 
      // for functor arity 
      Set<String> akeys = this.arityMap.keySet() ; 
      sb.append("arity \n") ;
      Iterator akeyiterator = akeys.iterator() ;
      while (akeyiterator.hasNext()) {  
         String name = (String)akeyiterator.next() ; 
         sb.append("   "+name+": ") ;
         Vector<Integer> vec = this.arityMap.get(name) ; 
         sb.append("<") ;
         Iterator vecit = vec.iterator() ;
         while (vecit.hasNext()) { 
            int a = (int)vecit.next() ; 
            sb.append(a) ; 
            if (vecit.hasNext()) sb.append(",") ; 
         }
         sb.append("> \n") ;
      }
      // for functor type 
      Set<String> tkeys = this.typeMap.keySet() ; 
      sb.append("type \n") ;
      Iterator tkeyiterator = tkeys.iterator() ;
      while (tkeyiterator.hasNext()) {  
         String name = (String)tkeyiterator.next() ; 
         sb.append("   "+name+": ") ;
         Vector<Byte> vec = this.typeMap.get(name) ; 
         sb.append("<") ;
         Iterator vecit = vec.iterator() ;
         while (vecit.hasNext()) { 
            byte b = (Byte)vecit.next() ; 
            sb.append(b) ; 
            if (vecit.hasNext()) sb.append(",") ; 
         }
         sb.append("> \n") ;
      }
      return sb.toString() ; 
   } 

   /** test */
   public static void main(String[] args) { 
      Theory thy = new Theory() ; // a dummy for now
      PredicateRecord nr = new PredicateRecord(thy) ;
      // make and record some data 
      String name1 ="∇" ; 
      nr.add(name1,2,(byte)0)  ;  
      nr.add(name1,1,(byte)0)  ;  
      nr.add(name1,2,(byte)2)  ;  
      nr.add("pro",3,(byte)0)  ;  
      nr.add("p(a)",1,(byte)0)  ;  
      nr.add("p(a)",2,(byte)0)  ;  

      System.out.println(nr.warn()) ;
      System.out.println(nr) ;
   }

}
     

/*
e.g., ∂(a,b), ∂b, a∂b, a∂
   "∂" ---> <2,1>       arity    
   "∂" ---> <0,1,2,3>   type
e.g., p(X,Y), p(s)      
   "p" -arity-> <2,1> 
   NB LNAME names should be FUNCTIONAL type 0.

Why predicative parametric would not included:
   true => p(a).
   P(X) => P(X,b).
This is too dynamic to predict in advance.
*/
